SystemOrganization addCategory: #'TP2-SistemaEjemplo-Traits'!
SystemOrganization addCategory: #'TP2-SistemaEjemplo'!
SystemOrganization addCategory: #'TP2-SistemaEjemplo-Entities'!
SystemOrganization addCategory: #'TP2-SistemaEjemplo-UnitTest'!
SystemOrganization addCategory: #'TP2-SistemaEjemplo-Tests'!

Trait named: #TMalo
	uses: {}
	category: 'TP2-SistemaEjemplo-Traits'!

Trait named: #TTrait1
	uses: {}
	category: 'TP2-SistemaEjemplo-Traits'!

Trait named: #TTrait2
	uses: {}
	category: 'TP2-SistemaEjemplo-Traits'!

Trait named: #TTrait3
	uses: {}
	category: 'TP2-SistemaEjemplo-Traits'!

Object subclass: #Clase1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-SistemaEjemplo'!

Object subclass: #Clase2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-SistemaEjemplo'!

!Clase2 methodsFor: 'as yet unclassified' stamp: 'lucas 5/19/2012 16:05'!
methodX
	"tengo un comentario"
	| asdsds |
	
	asdsds := 50.
	"un comentario random"
     ^True.

	! !

!Clase2 methodsFor: 'as yet unclassified' stamp: 'lucas 5/19/2012 14:54'!
methodY
	"a description of the method"

	! !

!Clase2 methodsFor: 'as yet unclassified' stamp: 'lucas 5/19/2012 21:07'!
methodZ
	"un comentario copado"
	| hola|
	hola := 3.
	"tengo un comentario aca"
	'asdsd'.
	^ hola*2

	! !

Object subclass: #Entity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-SistemaEjemplo'!

Entity subclass: #Entity1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-SistemaEjemplo-Entities'!

Entity subclass: #Entity2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-SistemaEjemplo-Entities'!

Entity2 subclass: #Entity3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-SistemaEjemplo-Entities'!

Entity3 subclass: #EntityBuena
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-SistemaEjemplo-Entities'!

TestCase subclass: #TestArchitecture
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-SistemaEjemplo-Tests'!

!TestArchitecture methodsFor: 'asserting' stamp: 'lucas 5/16/2012 16:41'!
classInHierachyOf: class subclass: subclass

	(subclass superclass == class) ifTrue: [^ true] ifFalse: 
	[(subclass superclass == Object) ifTrue: [^false] ifFalse: [^ (self classInHierachyOf: class subclass: (subclass superclass)) ]]

! !

!TestArchitecture methodsFor: 'accessing' stamp: 'lucas 5/19/2012 16:22'!
getCompiledMethodName: compiledMethod
	^ (((((compiledMethod  name findBetweenSubStrs:'#') at: 2) findBetweenSubStrs: '"')) at:1).! !

!TestArchitecture methodsFor: 'accessing' stamp: 'lucas 5/16/2012 16:20'!
listClassesFrom: category
	^ SystemOrganization classesInCategory: category! !

!TestArchitecture methodsFor: 'accessing' stamp: 'lucas 5/16/2012 16:17'!
listElementsFrom: category
	
	^((SystemOrganization listAtCategoryNamed: category) collect: [:each | Smalltalk globals at: each] )! !

!TestArchitecture methodsFor: 'accessing' stamp: 'lucas 5/19/2012 14:56'!
listMethodsFromCategory: category
	| systemClasses |
	
	systemClasses := self listClassesFrom: category.
	^ systemClasses inject: #()  into: [:mlist :class | mlist , (class methods) ].! !

!TestArchitecture methodsFor: 'accessing' stamp: 'lucas 5/16/2012 16:45'!
listTraitsFrom: category
	^((SystemOrganization listAtCategoryNamed: category) collect: [:each | Smalltalk globals at: each]) select: [ :each | each isTrait ]! !

!TestArchitecture methodsFor: 'asserting' stamp: 'lucas 5/19/2012 21:06'!
methodIsDocumented: method withNumOfChars: requestedCommentSize
	| possibleComment methodName source parts sourceOnlyLetters|

	methodName := self getCompiledMethodName: method.
	source := method getSource .
	parts := source findTokens: '"'.

	(parts size > 1) ifTrue: [
		possibleComment := (parts at: 2) onlyLetters.
		sourceOnlyLetters := source onlyLetters .
		
		Transcript show: possibleComment.
		Transcript show: (sourceOnlyLetters indexOfSubCollection: possibleComment).
		Transcript show: (methodName size).

		((sourceOnlyLetters indexOfSubCollection: possibleComment) = (methodName size)) ifTrue: [
				^ possibleComment size >= requestedCommentSize.
			]
			ifFalse: [ ^false ].
		
		] ifFalse: [^false]
	


	! !

!TestArchitecture methodsFor: 'extensions' stamp: 'lucas 5/18/2012 17:50'!
nameOfClass: testName
	^ testName copyFrom: 5 to: (testName size) ! !

!TestArchitecture methodsFor: 'testing' stamp: 'lucas 5/18/2012 18:35'!
testCaseCorrectlyNamed
	| utestNames classNames|
	
	utestNames := ((self listClassesFrom: 'TP2-SistemaEjemplo-UnitTest') select: [ :c | c superclass == TestCase ])collect: [:ut | ut name] .
	
	classNames := (self listClassesFrom: 'TP2-SistemaEjemplo') collect: [:c | c name] .
	
	utestNames do: [ :utn | self assert: (classNames includes: (self nameOfClass: utn)) description:  'all unit test names must match "Test + <class name>"'].
	
	
! !

!TestArchitecture methodsFor: 'testing' stamp: 'lucas 5/18/2012 19:16'!
testClassesHaveDocumentation
	"compruebo que todas las clases tengan una documentacion (texto mayor a 5 caracteres)"
	| classes |
	
	classes  := self listClassesFrom: 'TP2-SistemaEjemplo'.
	
	"
	classes do: [ :c | self assert: (c classComment size > 4) description: 'the class must have a comment of 5 characters or more']
	"! !

!TestArchitecture methodsFor: 'testing' stamp: 'lucas 5/18/2012 18:30'!
testEachClassWithUnitTest
	| utestNames classNames|
	
	utestNames := (self listClassesFrom: 'TP2-SistemaEjemplo-UnitTest') collect: [:ut | ut name] .
	
	classNames := (self listClassesFrom: 'TP2-SistemaEjemplo') collect: [:c | c name] .
 
	classNames do: [ :cn | self assert: (utestNames includes: ('Test' , cn)) description: 'each class need a test case']! !

!TestArchitecture methodsFor: 'testing' stamp: 'lucas 5/16/2012 16:32'!
testEntitiesOnPackage
	| classes |
	
	classes := self listClassesFrom:   'TP2-SistemaEjemplo-Entities'.
	
	
	classes do: [:each | self assert: (self classInHierachyOf: Entity subclass: each)] 
	! !

!TestArchitecture methodsFor: 'testing' stamp: 'lucas 5/19/2012 21:08'!
testMethodsHaveDocumentation
	| systemMethods |
	
	systemMethods := self listMethodsFromCategory: 'TP2-SistemaEjemplo'.
	
	
	systemMethods do: [:met | self assert: (self methodIsDocumented: met withNumOfChars: 5) description: 'the method: ', (self getCompiledMethodName: met), 'does not have a correct description'].

! !

!TestArchitecture methodsFor: 'testing' stamp: 'lucas 5/16/2012 16:44'!
testTraitsCorrectlyNamed
	| traitNames traits|
	
	traits := self listTraitsFrom:  'TP2-SistemaEjemplo-Traits'.
	traitNames := traits collect: [:t | t name].
	
	traitNames  do: [:tn |  self assert: $T equals: (tn first). 
		self assert: (tn size > 4) description: 'trait name must have 4 letters or more'.
		self assert: (tn second isUppercase) description: 'second letter of the trait name must be uppercase'.
		self assert: (tn third isLowercase ) description:  'third letter of the trait name must be lowercase']
	
	! !

!TestArchitecture methodsFor: 'testing' stamp: 'lucas 5/19/2012 14:35'!
testTraitsOnCorrectCategory
	"tengo que ver como conseguir todas las cosas de la app"
	| systemClasses |
	
	systemClasses := self listTraitsFrom: 'TP2-SistemaEjemplo'.
	
	systemClasses do: [:sc | self assert: (sc isTrait not) description: ('trait: ', sc , 'is not on the correct category')].! !

TestCase subclass: #TestClase1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-SistemaEjemplo-UnitTest'!

TestCase subclass: #TestClase2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-SistemaEjemplo-UnitTest'!

TestCase subclass: #TestEntity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-SistemaEjemplo-UnitTest'!
